#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll binpow(ll a, ll n)
{
    if(n==0) return 1;
    else if(n%2==1) return a*binpow(a,n-1);
    else
    {
        ll b = binpow(a,n/2);
        return b*b;
    }
}

ll f(ll a, ll n, ll mod)
{
    if(n==0) return 1;
    else if(n%2==1) return (a*f(a,n-1,mod))%mod;
    else
    {
        ll b = f(a,n/2,mod);
        return (b*b)%mod;
    }
}

ll B(ll p, ll k)
{
    ll res = 1;
    ll mod = binpow(p,k);
    for(ll i = 1; i<mod; i++)
    {
        if(i%p != 0) res = (res*i)%mod;
    }
    return res;
}

ll S(ll m, ll p, ll k)
{
    ll res = 1;
    ll mod = binpow(p,k);
    for(ll i = 1; i<=m; i++)
    {
        if(i%p != 0) res = (res*i)%mod;
    }
    return res;
}

ll calcmod(ll n, ll p, ll k)
{
    if(n==0) return 1;
    else
    {
        ll step = binpow(p,k);
        return (f(B(p,k),n/step,step)*S(n%step,p,k)*calcmod(n/p,p,k))%step;
    }
}

ll ret(ll k, ll q)
{
    ll r = q, res = 0;
    while(k/r > 0)
    {
        res += k/r;
        r *= q;
    }
    return res;
}

int main()
{
    freopen("factrl.in","r",stdin);
    freopen("factrl.out","w",stdout);
    ll n;
    cin >> n;
    ll A = calcmod(n,2,3), C = calcmod(n,5,3);
    //cout << A << ' ' << C << '\n';
    ll two = ret(n,2), five = ret(n,5);
    //cout << two << ' ' << five << '\n';
    ll n1, n2, n0;
    for(ll i = 1; i<8; i+=2)
    {
        if((f(5,five,8)*i) % 8 == A) { n1 = i; break; }
    }
    for(ll i = 1; i<125; i++)
    {
        if(i%5 != 0 && (f(2,two,125)*i) % 125 == C) { n2 = i; break; }
    }
    for(ll i = 0; i<1000; i++)
    {
        if(i%8 == n1 && i%125 == n2) { n0 = i; break; }
    }
    ll answer = f(2,two-five,1000);
    answer = (answer*n0)%1000;
    if(answer/100 == 0) cout << 0;
    if(answer/10 == 0) cout << 0;
    cout << answer << '\n';
}
