/* GCC */
#include <cstdio>
#include <vector>
#include <algorithm>
#include <utility>
#include <iostream>
using namespace std;

vector<pair<int, int> > A;
vector<pair<char, pair<int, int> > > X;

struct play{
    int age, lev, num, pos;
};
bool cmp(play a, play b){
    return (a.lev < b.lev || (a.lev == b.lev && a.age < b.age));
}

bool norm(play a, play b){ return (a.lev > b.lev && a.age > b.age); }

bool big(play a, play b){ return (a.age > b.age || (a.age == b.age && a.lev > b.lev)); }

vector<play> tree;
vector<play> men;
play zero;


/*play minst(play a, play b, int pos){
    if ( a  zero && a.age > men[pos].age && a.lev > men[pos].lev) return a;
    else if (b.lev > men[pos].lev) return b;
    else return zero;
}*/



play get(int v, int L, int R, int pos){
    //cout << v << " " << L << "," << R << "=" << pos << "|";
    if (R < pos) return zero;
    else {
        if (L == R) {
            if (norm(tree[v], men[pos])) return tree[v];
            else return zero;
        } else {
            int md = (L + R) >> 1;
            if (md < pos) return get((v << 1)+1, md+1, R, pos);
            else{
                //if (norm(tree[v<<1], men[pos])) return get(v<<1, L, md, pos);
                if (norm(tree[v<<1], men[pos])) return get(v<<1, L, md, pos);
                else return get((v<<1)+1, md+1, R, pos);
            }
        }
    }
}

void update(int v, int L, int R, int pos, play Man){
    if (L == R)
        tree[v] = Man;
    else{
        int md = (L + R) >> 1;
        if (md >= pos) update(v << 1, L, md, pos, Man);
        else update((v<<1)+1, md+1, R, pos, Man);
        if (big(tree[v<<1], tree[(v<<1)+1])) tree[v] = tree[v<<1];
        else tree[v] = tree[(v<<1)+1];
    }
}


int main(){
    freopen("cclub.in", "r", stdin);
    freopen("cclub.out", "w", stdout);
    zero.age = zero.lev = zero.num = 0;
    int n;
    scanf("%d\n", &n);
    X.resize(n);
    int NUM = 1;
    for(int i = 0; i < n; i++) {
        scanf("%c", &X[i].first);

        if(X[i].first == 'P') {
            scanf("%d %d\n", &X[i].second.first, &X[i].second.second);
            play hum;
            hum.age = X[i].second.first;
            hum.lev = X[i].second.second;
            hum.num = NUM;
            NUM++;
            men.push_back(hum);
        }
        else {
            scanf("%d\n", &X[i].second.first);
        }
    }
    NUM--;

    sort(men.begin(), men.end(), &cmp);

    vector<int> old_p(NUM);
    for(int i = 0; i < NUM; i++) {
        men[i].pos = i;
        old_p[men[i].num-1] = i;
    }

    tree.resize(4*NUM, zero);

    int POS = 0;
    for(int i = 0; i < n; i++){\
        if (X[i].first == 'P'){
            int pos = old_p[POS];
            update(1, 0, NUM-1, pos, men[pos]);
            //for(auto el : tree) cout << el.age << " " << el.lev << " " << el.num << "|"; cout << "\n";
            POS++;
        }

        if (X[i].first == 'G'){
            cout << get(1, 0, NUM-1, old_p[X[i].second.first-1]).num << "\n";
        }
    }



    return 0;
}
