/* GCC */
#include <bits/stdc++.h>
#define mp make_pair
#define X first
#define Y second

using namespace std;
typedef long long lint;
typedef pair<lint, lint> pll;
const lint inf = 1000*1000*1000 + 7;

vector<lint> t, a, b;
vector< pair<char, lint> > p;
vector< pair<pll, lint> > v;

ifstream fin("cclub.in");
ofstream fout("cclub.out");

void update(lint u, lint tl, lint tr, lint ind) {
    if (tl == tr) {
        t[u] = v[ind].X.Y;
    } else {
        lint tm = (tl + tr)/2;
        if (ind <= tm)
            update(2*u, tl, tm, ind);
        else
            update(2*u+1, tm+1, tr, ind);
        t[u] = max(t[2*u], t[2*u+1]);
    }
}

lint ma(lint u, lint tl, lint tr, lint val) {
    if (t[u] <= val) return 0;
    if (tl == tr) return tl;
    lint tm = (tl + tr)/2;
    if (t[2*u] > val)
        return ma(2*u, tl, tm, val);
    return ma(2*u+1, tm+1, tr, val);
}

lint s(lint u, lint tl, lint tr, lint ind, lint val) {
    if (ind < tl || tr < ind) return 0;
    if (t[u] <= val) return 0;
    if (tl == tr) return tl;

    lint tm = (tl + tr)/2;
    if (ind > tm+1)
        return s(2*u+1, tm+1, tr, ind, val);
    else if (ind == tm+1)
        return ma(2*u+1, tm+1, tr, val);

    lint c = s(2*u, tl, tm, ind, val);
    if (c == 0)
        return ma(2*u+1, tm+1, tr, val);
    return c;
}


int main() {

    fin.tie(0); fout.tie(0); ios_base::sync_with_stdio(0);

    v.push_back(mp(mp(0, 0), 0));
    lint n;
    fin >> n;
    lint m = 0;
    char c;
    for (lint i = 0, ag, l; i < n; i++) {
        fin >> c;
        if (c == 'P') {
            fin >> ag >> l;
            v.push_back(mp(mp(l, ag), ++m));
            p.push_back(mp(c, m));
        } else {
            fin >> ag;
            p.push_back(mp(c, ag));
        }
    }

    sort(v.begin(), v.end());
    a.resize(m+1);
    b.resize(m+1);
    t.resize(4*m+1);

    for (lint i = 1; i <= m; i++)
        a[v[i].Y] = i;

    lint i = 1, j = 1;

    while (i <= m) {
        while (j <= m && v[i].X.X == v[j].X.X) j++;
        while (i < j) b[i++] = j;
    }

    for (lint i = 0; i < n; i++) {
        if (p[i].X == 'P')
            update(1, 1, m, a[p[i].Y]);
        else {
            j = b[a[p[i].Y]];
            lint ans = s(1, 1, m, j, v[a[p[i].Y]].X.Y);
            fout << v[ans].Y << '\n';
        }
    }

    return 0;
}
