/* GCC */
#include <bits/stdc++.h>
#define mp make_pair

using namespace std;

struct st {
    int power, old, num;
    st(){
        power = 0;
        old = 0;
        num = 0;
    }
    st(int a, int b, int c){
        power = a;
        old = b;
        num = c;
    }
};
bool operator < (st a, st b) { return a.power < b.power || (a.power == b.power && a.old < b.old); }

const int maxn = 200001;
const int inf = 1000000007;
int tree[4  * maxn];
int a[maxn];
int b[maxn];
//==================tree===================================

void update(int v, int tl, int tr, int pos, int value){
    if (tl == tr){
        tree[v] = value;
        return;
    }
    int m = (tl + tr) >> 1;
    if (pos <= m) update(v << 1, tl, m, pos, value);
    else update((v << 1) | 1, m + 1, tr, pos, value);
    tree[v] = max(tree[v << 1], tree[(v<< 1) | 1]);
}

int get_max(int v, int tl, int tr, int value){
    if (tree[v] <= value) return inf;
    if (tl == tr) return tl;
    int m = (tl + tr) >> 1;
    if (tree[v << 1] > value) return get_max(v << 1, tl, m, value);
    return get_max((v << 1) | 1, m + 1, tr, value);
}

int get(int v, int tl, int tr, int pos, int value){
    if (tree[v] <= value) return inf;
    if (tr == tl) return tl;
    int m = (tl + tr) >> 1;
    if (pos > m) return get((v << 1) | 1, m + 1, tr, pos, value);
    int cur = get(v << 1, tl, m, pos, value);
    if (cur == inf)
        cur = get_max((v << 1) | 1, m + 1, tr, value);
    return cur;
}

//=================end_of_tree================================


vector < pair<char, int> > z;
vector < st > v;


int main()
{
    ifstream InPut("cclub.in");
    ofstream OutPut("cclub.out");
    int q, n = 0;
    InPut >> q;
    st temp = st();
    v.push_back(temp);
    for (int i = 0; i < q; ++i){
        char ch;
        InPut >> ch;
        if (ch == 'P'){
            ++n;
            st cur;
            InPut >> cur.old >> cur.power;
            cur.num = n;
            z.push_back(mp(ch, n));
            v.push_back(cur);
        }
        else {
            int k;
            InPut >> k;
            z.push_back(mp(ch, k));
        }
    }
    InPut.close();
    sort(v.begin(), v.end());
    for (int i = 1; i < v.size(); ++i)
        {a[v[i].num] = i;}
    int i = 1;
    int j = 1;
    while (i < v.size()){
        while (j < v.size() && v[i].power == v[j].power) ++j;
        while (i < j){ b[v[i].num] = j; i++;}
    }
    for (int it = 0; it < z.size(); ++it){
        char ch = z[it].first;
        if (ch == 'P') {
                update(1, 1, n, a[z[it].second], v[a[z[it].second]].old);
                continue;
        }
        int pos = b[z[it].second];
        int value = v[a[z[it].second]].old;
        if (pos == n + 1) { OutPut << 0 << '\n'; continue; }
        int cur = get(1, 1, n, pos, value);
        if (cur == inf) OutPut << 0 << '\n';
        else OutPut << v[cur].num << '\n';
    }
    OutPut.close();
    return 0;
}
